!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004, 2006. All rights reserved.
!---------------------------------------------------------------------
!= Subroutine DynImpFunc
!
! Developer:: SUGIYAMA Ko-ichiro, ODAKA Masatsugu
! Version::   $Id: dynimpfunc.f90.lapack,v 1.7 2008-06-26 10:56:17 odakker2 Exp $ 
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2003. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ˡѤϳزγƹη׻⥸塼.
!ʡؿ򱢲ˡǲ򤯺ݤɬפȤʤ, Ǥη, 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * Υ, 岼ȤƱľ®٤ͿƤ. 
!  *  2 ٤ΥۤѤƤ뤿, differentiate_center4 ⥸塼ꤹ뤳ȤϤǤʤ.
!
!== Future Plans
!

module DynImpFunc
  !
  !ˡѤϳزγƹη׻⥸塼.
  !ʡؿ򱢲ˡǲ򤯺ݤɬפȤʤ, Ǥη, 
  !
  !ܥ⥸塼Ǥϲʳط׻饤֥Ȥ, ʲ򥵥ݡȤ. 
  !  * MATRIX/MPP (HITACH Ŭ Fortran)
  !  * LAPACK     
  !
  

  !⥸塼ɤ߹
  use dc_types, only: DP
  use dc_iounit, only: FileOpen
  use dc_message, only: MessageNotify     !å
  
  use gridset, only: &
    &                imin,            &! x β
    &                imax,            &! x ξ
    &                jmin,            &! y β
    &                jmax,            &! y ξ
    &                kmin,            &! z β
    &                kmax,            &! z ξ
    &                nx,              &! x ʪΰβ
    &                ny,              &! x ʪΰξ
    &                nz                ! y ʪΰβ
  use axesset, only: z_dz, r_dz, xyz_dx, xyr_avr_xyz ! ʻҴֳ
  use timeset, only: DelTimeShort         !û֥ƥå
  use damping, only: DampSound            !Ȥθ그
  use constants,only: CpDry               !ʬǮ
  use basicset, only: xyz_VelSoundBasicZ, &!ܾβ® 
    &                 xyz_DensBasicZ,     &!ܾ̩
    &                 xyz_PotTempBasicZ    !ܾβ
  use xyz_deriv_module, only: xyr_dz_xyz, xyz_dz_xyr, xyz_dx_pyz, xyz_dy_xqz

  !ۤηػ
  implicit none

  !°λ
  private

  !ؿ public 
  public xyz_Exner_init     !롼
  public xyz_Exner          !ʡؿη׻
  public xyr_GradPi         !ˡѤϷ
  
  real(DP)               :: beta  = 5.0d-1    !󥯥˥륽ˡʤ 0.5
                                             !ˡʤ 1
  real(DP), allocatable  :: xyz_F1BasicZ(:,:,:)  !η׻Ѥ
  real(DP), allocatable  :: xyr_F2BasicZ(:,:,:)  !η׻Ѥ
  real(DP), allocatable  :: xyz_VPotTempBasicZ(:,:,:) 
                                             !ܾβ

  integer               :: N = 10            !/μ, ˡ
  integer               :: M = 10            !ȿ
  integer               :: NUD = 1           !ξ廰ʬ
  integer               :: NLD = 1           !βʬ
  integer               :: NAL = 1           !LU ʬη L ˡ
  integer               :: NA = 3            !NUD + NLD + 1
  integer               :: unit              !ֹ 
  integer               :: ix, jy, kz        !롼ѿ

  real(DP), allocatable :: A(:)              !гʬ
  real(DP), allocatable :: B(:)              !ξ廰ʬ
  real(DP), allocatable :: C(:)              !βʬ
  real(DP), allocatable :: AU2(:,:)          !LU ʬη U (2 )
  real(DP), allocatable :: AL1(:)            !LU ʬη L (1 )
  real(DP), allocatable :: AL2(:,:)          !LU ʬη L (2 )
  integer, allocatable  :: IP(:)             !ʬԥܥåȸ򴹤ξǼ

  integer, save :: RegXMin = 1
  integer, save :: RegXMax = 1
  integer, save :: RegYMin = 1
  integer, save :: RegYMax = 1
  integer, save :: RegZMin = 1
  integer, save :: RegZMax = 1

  !ͤ¸
  save beta, xyz_F1BasicZ, xyr_F2BasicZ, xyz_VPotTempBasicZ
  save N, M, NUD, NLD, NAL, NA
  save A, B, C, AU2, AL1, AL2, IP

contains

!!!--------------------------------------------------------------------!!!
  subroutine xyz_Exner_init()
    !
    !ʡؿ򱢲ˡǲ򤯺ݤɬפȤʤ, Ǥ, 
    !LU ʬԤ. 
    !

    !ۤηػ
    implicit none

    real(DP)  :: DTS ! ûֳʻ

    DTS = DelTimeShort

    RegXMin = 1
    RegXMax = nx
    RegYMin = 1
    RegYMax = ny
    RegZMin = 1
    RegZMax = nz

    !γդ
    allocate(  &
      & A(RegZMin:RegZMax),                                  &
      & B(RegZMin+1:RegZMax),                                &   
      & C(RegZMin:RegZMax-1),                                &  
      & xyz_F1BasicZ(imin:imax,jmin:jmax,kmin:kmax), &
      & xyr_F2BasicZ(imin:imax,jmin:jmax,kmin:kmax),&
      & xyz_VPotTempBasicZ(imin:imax,jmin:jmax,kmin:kmax) )

    !----------------------------------------------------------------
    ! ȶ̤Ѥͤ
    !----------------------------------------------------------------
    !̤
    xyz_VPotTempBasicZ = xyz_PotTempBasicZ 

    !η׻
    !  A, B, C , F1BasicZ  F2BasicZ  X ˰ͤʤΤ. 
    !  RegXMax, RegYMax ͤɽ뤳ȤȤ. 

    xyz_F1BasicZ =                                                &
      &  ( xyz_VelSoundBasicZ ** 2.0d0 )                          &
      &   / (CpDry * xyz_DensBasicZ * (xyz_VPotTempBasicZ ** 2.0d0))

    xyr_F2BasicZ =                                                 &
      &  xyr_avr_xyz(                                               &
      &    CpDry * xyz_DensBasicZ * ( xyz_VPotTempBasicZ ** 2.0d0 ) &
      &   )
    
    A(RegZMin+1: RegZMax-1) =                                &
      & (beta ** 2.0d0)                                    &
      &    * xyz_F1BasicZ(RegXMax,RegYMax,RegZMin+1: RegZMax-1)      &  
      &    * (                                               &
      &          xyr_F2BasicZ(RegXMax,RegYMax,RegZMin+1: RegZMax-1)  &
      &            / r_dz(RegZMin+1: RegZMax-1)              &
      &        + xyr_F2BasicZ(RegXMax,RegYMax,RegZMin  : RegZMax-2)  &
      &            / r_dz(RegZMin: RegZMax-2)                &
      &       )                                              &
      &    * (DTS ** 2.0d0)                                  &
      &    / z_dz(RegZMin+1: RegZMax-1)                      &
      & + 1.0d0

    A(RegZMin) =                                        &
      & (beta ** 2.0d0)                               &
      &   * xyz_F1BasicZ(RegXMax,RegYMax,RegZMin)       &
      &   * xyr_F2BasicZ(RegXMax,RegYMax,RegZMin)       &
      &     / r_dz(RegZMin)                             &
      &   * (DTS ** 2.0d0)                              &
      &   / z_dz(RegZMin)                               &
      & + 1.0d0                                         

    A(RegZMax) =                                        &
      & (beta ** 2.0d0)                               &
      &   * xyz_F1BasicZ(RegXMax,RegYMax,RegZMax)       &
      &   * xyr_F2BasicZ(RegXMax,RegYMax,RegZMax-1)     &
      &     / r_dz(RegZMax-1)                           &
      &   * (DTS ** 2.0d0)                              &
      &   / z_dz(RegZMax)                               &
      & + 1.0d0                                         
    
    B(RegZMin+1:RegZMax) =                             &
      & - (beta ** 2.0d0)                               &
      &   * xyz_F1BasicZ(RegXMax,RegYMax,RegZMin:RegZMax-1)    &
      &   * xyr_F2BasicZ(RegXMax,RegYMax,RegZMin:RegZMax-1)    &
      &     / r_dz(RegZmin:RegZMax-1)                   &
      &   * (DTS ** 2.0d0)                     &
      &   / z_dz(RegZMin:RegZMax-1)
    
    C(RegZMin: RegZMax-1) =                           &
      & - ( beta ** 2.0d0 )                           &
      &   * xyz_F1BasicZ(RegXMax,RegYMax,RegZMin+1:RegZMax)    &
      &   * xyr_F2BasicZ(RegXMax,RegYMax,RegZMin  :RegZMax-1)  &
      &     / r_dz(RegZmin:RegZMax-1)                   &
      &   * (DTS ** 2.0d0) &
      &   / z_dz(RegZMin+1:RegZMax)


    !ǥХåϥե륪ץ. . 
!    call FileOpen(unit, file="dynimpfunc_log", mode='w')
!    write(unit,*) "kz, A_k"
!    write(unit,*) "------------------------------------"
!    do kz = RegZmin, RegZmax
!      write(unit,*) kz, A(kz)
!    end do
!    write(unit,*) "------------------------------------"
!    write(unit,*) "kz, B_k"
!    write(unit,*) "------------------------------------"
!    do kz = RegZmin+1, RegZmax
!      write(unit,*) kz, B(kz)
!    end do
!    write(unit,*) "------------------------------------"
!    write(unit,*) "kz, C_k"
!    write(unit,*) "------------------------------------"
!    do kz = RegZmin, RegZmax-1
!      write(unit,*) kz, C(kz)
!    end do
!    write(unit,*) "------------------------------------"
!    close(unit)


    !----------------------------------------------------------------
    !  LU ʬ
    !----------------------------------------------------------------
    !礭ݴ
    N   = RegZMax - RegZMin +1 !/μ, ˡ
    M   = (RegXMax - RegXMin +1)*(RegYMax - RegYMin +1) 
                               !ȿ
    NUD = 1                    !ξ廰ʬ
    NLD = 1                    !βʬ
    NAL = NLD                  !LU ʬη L ˡ
    NA  = NUD + NLD + 1

    !γ
    allocate( AL1(N), AL2(NAL, N), AU2(NA, N), IP(N) )

    !LU ʬμ¹
    !  LAPACK 
    call ResolvLU_Lapack( )

   
  end subroutine xyz_Exner_init
  

!!!--------------------------------------------------------------------!!!
  function xyz_Exner(xyr_FzNl, &
    &                pyz_VelXNs, pyz_VelXAs, &
    &                xqz_VelYNs, xqz_VelYAs, &
    &                xyr_VelZNs, xyz_ExnerNs)
    !
    !ˡѤʡؿη׻. 
    !

    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in)   :: pyz_VelXNs &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !® u []
    real(DP), intent(in)   :: pyz_VelXAs &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !® u [+]
    real(DP), intent(in)   :: xqz_VelYNs &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !® v []
    real(DP), intent(in)   :: xqz_VelYAs &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !® v [+]
    real(DP), intent(in)   :: xyr_VelZNs &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !® w []
    real(DP), intent(in)   :: xyr_FzNl &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !Z γϹ[t]
    real(DP), intent(in)   :: xyz_ExnerNs &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !̵
    real(DP)               :: xyz_Exner &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !̵[+]

    !ѿ
    real(DP)  :: D1(imin:imax,jmin:jmax,kmin:kmax)  
    real(DP)  :: D2(RegXMin:RegXMax,RegYMin:RegYMax,RegZMin:RegZMax)  
    real(DP)  :: D((RegXMax-RegXMin+1)*(RegYMax-RegYMin+1),(RegZMax-RegZMin+1))
    real(DP)  :: E(imin:imax,jmin:jmax,kmin:kmax)  
    real(DP)  :: F(imin:imax,jmin:jmax,kmin:kmax)  
    real(DP)  :: xyz_DivVelNs(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)               :: DTS ! ûֳʻҴֳ

    DTS = DelTimeShort

    !ѿν
    xyz_Exner = 0.0d0
    
    !®٤μ«׻
    xyz_DivVelNs =  xyz_dx_pyz( pyz_VelXNs )   &
      &             + xyz_dy_xqz( xqz_VelYNs ) &
      &             + xyz_dz_xyr( xyr_VelZNs )
  
    !׻Τη
    E = xyr_dz_xyz( DampSound * xyz_DivVelNs )                      &
      & - ( 1.0d0 - beta ) * xyr_dz_xyz( xyz_ExnerNs )              &
      & + xyr_FzNl / xyr_avr_xyz( CpDry * xyz_VPotTempBasicZ ) 
    
    F = - beta * xyz_F1BasicZ * DTS &
      & * xyz_dz_xyr(                                               &
      &    xyr_avr_xyz( xyz_DensBasicZ * xyz_VPotTempBasicZ)        &
      &    * (                                                      &
      &         xyr_VelZNs                                          &
      &       - xyr_avr_xyz(CpDry * xyz_VPotTempBasicZ) * DTS       &
      &         * (                                                 &
      &               (1.0d0 - beta) * xyr_dz_xyz( xyz_ExnerNs )    &
      &             - xyr_dz_xyz( DampSound * xyz_DivVelNs )        &
      &            )                                                &
      &       + xyr_FzNl * DTS                                      &
      &      )                                                      &
      &   ) 

    D1 = xyz_ExnerNs                                           &
      & - (1.0d0 - beta)                                            &
      &   * xyz_F1BasicZ * DTS                                      &
      &   * xyz_dz_xyr(                                             &
      &       xyr_avr_xyz(xyz_DensBasicZ * xyz_VPotTempBasicZ) * xyr_VelZNs   &
      &     )                                                       &
      & - (xyz_VelSoundBasicZ ** 2.0d0) *DTS        & 
      &   / (CpDry * xyz_VPotTempBasicZ)                            &
      &   * xyz_dx_pyz( pyz_VelXAs )                                &
      & - (xyz_VelSoundBasicZ ** 2.0d0) *DTS        & 
      &   / (CpDry * xyz_VPotTempBasicZ)                            &
      &   * xyz_dy_xqz( xqz_VelYAs )                                &
      & + F

    D1(:,:,RegZMin) = D1(:,:,RegZMin)                       &
      & - beta * xyz_F1BasicZ(:,:,RegZMin) * (DTS ** 2.0d0)         &
      &   * xyr_F2BasicZ(:,:, RegZMin-1) * E(:,:,RegZMin-1)         &
      &   / z_dz(RegZMin)
    
    D1(:,:,RegZMax) = D1(:,:,RegZMax)                       &
      & + beta * xyz_F1BasicZ(:,:,RegZMax) * (DTS ** 2.0d0)         &
      &   * xyr_F2BasicZ(:,:,RegZMax) * E(:,:,RegZMax)              &
      &   / z_dz(RegZMax)     

    D2 = D1(RegXMin:RegXMax,RegYMin:RegYMax,RegZMin:RegZMax)

    do kz = RegZMin, RegZMax
      do jy = RegYMin, RegYMax 	
        do ix = RegXMin, RegXMax 	
	  D(ix + (RegXMax-RegXMin+1) * (jy - 1), kz) =  D2(ix,jy,kz)
        end do 
      end do
    end do	
   
    !-----------------------------------------------------------
    !ϢΩ켡β
    !------------------------------------------------------------

    !η׻
    !  LAPACK 
    call LinSolv_Lapack( D )

    !ͤ

    do kz = RegZMin, RegZMax
      do jy = RegYMin, RegYMax 	
        do ix = RegXMin, RegXMax 	
          xyz_Exner(ix,jy,kz) = D(ix + (RegXMax-RegXMin+1) * (jy - 1 ), kz)
        end do 
      end do
    end do	
   
  end function xyz_Exner

!!!--------------------------------------------------------------------!!!
  subroutine ResolvLU_Lapack(  )
    !
    ! 3  LU ʬ(). LAPACK 
    !

    !ۤηػ
    implicit none

    !ѿ
    integer    :: INFO  !Υǥå
    
    !ѿν
    INFO = 0
    
    !η׻. LAPACK . 
    call DGTTRF(N, C, A, B, AL1, IP, INFO)
    
!    !Υǥå. 
!    if (INFO /= 0) then
!      call MessageNotify("Error", "lapack_linear", "INFO is not 0")
!      stop
!    end if
    
  end subroutine ResolvLU_Lapack
  

!!!--------------------------------------------------------------------!!!
  subroutine LinSolv_Lapack( X )
    !
    !LU ʬ򤵤줿 3 ϢΩ 1 (). LAPACK 
    !

    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(inout) :: X(M, N)     !/
    real(DP)                :: TX(N, M)    !ž֤
    integer                :: NRHS         !
    integer                :: INFO
    integer                :: LDB
    character(1),parameter :: TRANS = 'N'

    !ѿν
    NRHS = M
    INFO = 0
    LDB  = N
    TX = transpose( X )
    
    !η׻. LAPACK . 
    call DGTTRS(TRANS, N, NRHS, C, A, B, AL1, IP, TX, LDB, INFO)

    !ν
    X = transpose( TX )
     
    !Υǥå. 
!    if (INFO /= 0) then
!      call MessageNotify("Error", "lapack_linear", "INFO is not 0")
!      stop
!    end if
     
  end subroutine LinSolv_Lapack

!!!--------------------------------------------------------------------!!!
  function xyr_GradPi(xyz_ExnerA, xyz_ExnerN, pyz_VelX, xqz_VelY, xyr_VelZ)
    !
    ! x ȾʻҤ줿ǤΰϷϹη׻. 
    ! 󥯡˥륽ˡѤ뤿,    +ӤǤ
    ! ʡؿͤȤƼ.
    ! ȸޤ᤿꼰Ƥ뤳Ȥ.
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in)  :: xyz_ExnerA &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                               !ʡؿξ
    real(DP), intent(in)  :: xyz_ExnerN &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                               !ʡؿξ
    real(DP), intent(in)  :: pyz_VelX &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                               !ʿ®
    real(DP), intent(in)  :: xqz_VelY &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                               !ʿ®
    real(DP), intent(in)  :: xyr_VelZ &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                               !ľ®
    real(DP)              :: xyr_GradPi &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                               !Ϸ
    real(DP)              :: xyz_DivVel &
      &                     (imin:imax,jmin:jmax,kmin:kmax)
                                               !®٤μ«

    !®٤μ«
    xyz_DivVel =  xyz_dx_pyz( pyz_VelX )   &
      &           + xyz_dy_xqz( xqz_VelY ) &
      &           + xyz_dz_xyr( xyr_VelZ )
    
    !® w ΰϸ
!    xyr_GradPi = 0.0d0
    xyr_GradPi =   &
      & xyr_avr_xyz(CpDry * xyz_PotTempBasicZ )   &
      &   * (                                                      &
      &       beta * xyr_dz_xyz( xyz_ExnerA )                         &
      &       + (1.0d0 - beta) * xyr_dz_xyz( xyz_ExnerN )             &
      &       - xyr_dz_xyz( DampSound * xyz_DivVel )                  &
      &     )                                              
    
  end function xyr_GradPi
  
  
end module DynImpFunc
